import unittest

from csst_dfs_client.catalog import search

class CatalogTestCase(unittest.TestCase):

    def setUp(self):
        pass

    def test_search(self):
        result = search(
            ra=90, 
            dec=24.5, 
            radius=0.21, 
            columns = ['ref_epoch','ra','ra_error','dec','dec_error','parallax','parallax_error','pmra','pmra_error','pmdec','pmdec_error','phot_g_mean_mag','source_id'],
            catalog_name='gaia3', 
            min_mag=-1, 
            max_mag=-1, 
            obstime = -1, 
            limit = 10
        )
        print(result)
        self.assertEqual(result.code, 200, "error code: " + str(result.code) + ", message: " + result.message)
        self.assertIsNotNone(result.data, "error message: " + result.message)
